# -*- coding: utf-8 -*-
from openerp.http import request
from eiru_logging import make_info_log

_MODEL = 'account.bank.statement.config'

def get_bank_statement_config():
    make_info_log('GET StatementConfig')
    return request.env[_MODEL].search([('active', '=', True)])

    # import pdb_pdb; pdb_pdb.set_trace()
''' Configuracion de Caja '''
def get_account_bank_statement_config():
    make_info_log('GET StatementConfig Init')

    return [{
        'transfer': {
            'userIds': map(lambda x: x.id, config.transfer_user_ids),
            'statementIds': map(lambda x: x.id, config.transfer_statement_ids) ,
            'negativeAmount': config.transfer_negative_amount
        },
        'inputCashBox': {
            'userIds': map(lambda x: x.id, config.input_cash_box_user_id),
            'statementIds': map(lambda x: x.id, config.input_cash_box_statement_ids)
        },
        'outputCashBox': {
            'userIds': map(lambda x: x.id, config.output_cash_box_user_id),
            'statementIds': map(lambda x: x.id, config.output_cash_box_statement_ids),
            'negativeAmount': config.output_negative_amount
        },
        'delete': {
            'outputUserIds': map(lambda x: x.id, config.delete_output_user_ids),
            'inputUserIds': map(lambda x: x.id, config.delete_input_user_ids),
            'transferUserIds': map(lambda x: x.id, config.delete_transfer_user_ids)
        },
        'statementOpen': config.statement_open_config,
        'statementConfirm' :{
            'userIds': map(lambda x: x.id, config.statement_confirm_user),
            'transferUserIds': map(lambda x: x.id , config.statement_confirm_transfer_user),
            'balanceUserIds': map(lambda x: x.id, config.statement_confirm_balance),
            'negativeAmountUserIds': map(lambda x: x.id, config.statement_confirm_negative_amount)
        },
        'statementCancelUserIds': map(lambda x: x.id, config.statement_cancel_user),
        'statementUnlinkUserIds': map(lambda x: x.id, config.statement_unlink_user)
    } for config in request.env[_MODEL].search([('active', '=', True)],order='id')]

'''
name = fields.Char('Name', required=True, default="Configuración Cajas")
active = fields.Boolean('Active', default=True)

## Forma de Importar Pagso en caja Ventas/compras/RRHH
import_statement_payments = fields.Selection([('automatic_import', 'Automático'),('manual_import','Manual')],'Importar pagos en caja',default='automatic_import',help='Tipo de importar los pago en caja', required=True)
import_statement_payslip = fields.Selection([('automatic_import', 'Automático'),('manual_import','Manual')],'Importar pagos de RRHH en caja',default='automatic_import',help='Tipo de importar los pago en caja', required=True)

## TRANSFERENCIA
transfer_user_ids = fields.Many2many('res.users', 'statement_config_transfer_user', 'account_bank_statement_config_id','res_users_id', string='statement_transfer_user')
transfer_statement_ids = fields.Many2many('account.bank.statement.type', 'statement_config_transfer_statement', 'account_bank_statement_config_id', 'account_bank_statement_type_id', string="statement_config_transfer_statement")
transfer_negative_amount = fields.Boolean('transfer_negative_amount', default=False, help="Permitir transferencia sin saldo en caja")
delete_transfer_user_ids = fields.Many2many('res.users', 'statement_config_deleted_transfer_user', 'account_bank_statement_config_id','res_users_id', string='statement_delete_transfer_user')

## Poner Dinero
input_cash_box_user_id = fields.Many2many('res.users', 'statement_config_input_user', 'account_bank_statement_config_id', 'res_users_id', string='statement_input_user')
input_cash_box_statement_ids = fields.Many2many('account.bank.statement.type', 'statement_config_input_statement', 'account_bank_statement_config_id', 'account_bank_statement_type_id', string="statement_config_input_statement")
delete_input_user_ids = fields.Many2many('res.users', 'statement_config_deleted_input_user', 'account_bank_statement_config_id','res_users_id', string='statement_delete_input_user')

## Sacar Dinero
output_cash_box_user_id = fields.Many2many('res.users', 'statement_config_output_user', 'account_bank_statement_config_id', 'res_users_id', string='statement_output_user')
output_cash_box_statement_ids = fields.Many2many('account.bank.statement.type', 'statement_config_output_statement', 'account_bank_statement_config_id', 'account_bank_statement_type_id', string="statement_config_output_statement")
output_negative_amount = fields.Boolean('output_negative_amount', default=False, help="Permitir sacar dinero sin saldo en caja")
delete_output_user_ids = fields.Many2many('res.users', 'statement_config_deleted_output_user', 'account_bank_statement_config_id','res_users_id', string='statement_delete_output_user')

## Abrir Cajas
statement_open_config = fields.Boolean('statement_open_config', default=False, help="Permitir abrir mas de una caja(por usuario, por diario, por tipo de caja)")

## statement confirm
statement_confirm_user = fields.Many2many('res.users', 'statement_config_confirm_user', 'account_bank_statement_config_id', 'res_users_id', string='Usuario permitido para cerrar Caja ')
statement_confirm_transfer_user = fields.Many2many('res.users', 'statement_config_confirm_transfer_user', 'account_bank_statement_config_id', 'res_users_id', string='Usuario permitido para realizar transferencia')
statement_confirm_balance = fields.Many2many('res.users', 'statement_config_confirm_balance', 'account_bank_statement_config_id', 'res_users_id', string='Usuario permitido para ajuste de cierre')
statement_confirm_negative_amount = fields.Many2many('res.users', 'statement_confirm_negative_amount', 'account_bank_statement_config_id', 'res_users_id', string='Usuario permitido para cerrar caja sin saldo ')
## statement Cancel
statement_cancel_user = fields.Many2many('res.users', 'statement_config_cancel_user', 'account_bank_statement_config_id', 'res_users_id', string='Usuarios permitidos para cancelar Cajas')
## Statement Unlink
statement_unlink_user = fields.Many2many('res.users', 'statement_config_unlink_user', 'account_bank_statement_config_id', 'res_users_id', string='Usuarios permitidos para Eliminar Cajas')
'''
