# -*- coding: utf-8 -*-
from openerp.http import request

_MODEL='cash.box.in'

def verify_casboxin(lineId):
    return request.env[_MODEL].search([('line_id.id', '=', lineId)])

def writer_casboIn(id, value):
    input = request.env[_MODEL].browse(id)
    if (not input):
        return False
    return input.sudo().write(value)

def create_cashbox_input(data):
    from account_bank_statement import search_account_bank_statement
    from account_bank_statement_line import create_statement_line

    ''' Statement '''
    statement = search_account_bank_statement(data['casboxOriginId'])
    if (not statement):
        return {
            'state': False,
            'message': 'Error. Obtener la Caja'
        }

    lineInput = create_statement_line({
        'statement_id': statement['id'],
        'name': "ENTRADA DE DINERO - Ref. %s" % (data['description']),
        'amount': data['amount'] ,
        'ref': 'ENTRADA DE DINERO',
        'account_id': statement['accountId'],
        'journal_id': statement['journalId'],
        # 'is_deleted': True
    })

    if (not lineInput):
        return {
            'state': False,
            'message': 'Error en la entrada de dinero de la caja.'
        }

    casboxInput = request.env[_MODEL].sudo().create({
        'name': "ENTRADA DE DINERO %s" %(statement['name']),
        'amount': data['amount'],
        'ref': data['description'],
        'date': lineInput.date,
        'line_id': lineInput.id,
        'statement_id': statement['id'],
    })

    result ={
        'state': False,
        'message': "Error en la entrada de dinero de la caja"
    }

    if (casboxInput):
        result ={
            'state': True,
            'message': "Entrada de dinero registrada con suceso."
        }

    return result
