# -*- coding: utf-8 -*-
from openerp.http import request

_MODEL='cash.box.out'

def verify_casbox_out(lineId):
    return request.env[_MODEL].search([('line_id.id', '=', lineId)])

def writer_casboOut(id, value):
    outPut = request.env[_MODEL].browse(id)
    if (not outPut):
        return False
    return outPut.sudo().write(value)

def create_cashbox_output(data):
    from account_bank_statement import search_account_bank_statement
    from account_bank_statement_line import create_statement_line

    ''' Statement '''
    statement = search_account_bank_statement(data['casboxOriginId'])
    if (not statement):
        return {
            'state': False,
            'message': 'Error. Obtener la Caja'
        }

    lineOutput = create_statement_line({
        'statement_id': statement['id'],
        'name': "SALIDA DE DINERO - Ref. %s" % (data['description']),
        'amount': -data['amount'],
        'ref': 'SALIDA DE DINERO',
        'account_id': statement['accountId'],
        'journal_id': statement['journalId'],
        # 'is_deleted': True
    })

    if (not lineOutput):
        return {
            'state': False,
            'message': 'Error en la salida de dinero de la caja.'
        }

    casboxInput = request.env[_MODEL].sudo().create({
        'name': "SALIDA DE DINERO %s" %(statement['name']),
        'amount': data['amount'],
        'ref': data['description'],
        'date': lineOutput.date,
        'line_id': lineOutput.id,
        'statement_id': statement['id'],
    })

    result ={
        'state': False,
        'message': "Error en la salida de dinero de la caja"
    }

    if (casboxInput):
        result ={
            'state': True,
            'message': "Extracción de dinero registrada con suceso."
        }

    return result
