import Vue from 'vue'
import Vuex from 'vuex'

/* Store*/
import state from '@/store/state'
import getters from '@/store/getters'
import mutations from '@/store/mutations'
import actions from '@/store/actions'
// modules
import currenciesModule from '@/store/modules/currencies'
import dateModule from '@/store/modules/date'
import journalsModule from '@/store/modules/journals'
import resPartners from '@/store/modules/resPartners'
import resUsersModule from '@/store/modules/resUsers'
import statementModule from '@/store/modules/statement'
import statementAction from '@/store/modules/statementAction'
import statementConfigModule from '@/store/modules/statementConfig'
import statementLine from '@/store/modules/statementLine'
import statementTypeModule from '@/store/modules/statementType'
import userModule from '@/store/modules/user'

//Actions Statement

/* Module */
Vue.use(Vuex)

const store = new Vuex.Store({
    state,
    getters,
    mutations,
    actions,
    modules: {
        currenciesModule,
        dateModule,
        journalsModule,
        resPartners,
        resUsersModule,
        statementModule,
        statementAction,
        statementConfigModule,
        statementLine,
        statementTypeModule,
        userModule,
    },
    strict: true
})

export default store
