const initialState = {
    currencies: null,
    loadingCurrencies: false
}
const state = {
    currencies: initialState.currencies,
    loadingCurrencies: initialState.loadingCurrencies
}
const getters = {
    currencies(state) {
        return state.currencies;
    },
    loadingCurrencies(state) {
        return state.loadingCurrencies;
    }
}
const mutations = {
    setCurrencies(state, payload) {
        state.currencies = payload
    },
    setLoadingCurrencies(state, payload) {
        state.loadingCurrencies = !!payload
    }
}
const actions = {
    initCurrencies({ commit }, payload) {
        commit('setCurrencies', payload)
        commit('setLoadingCurrencies', payload)
    },
    resetCurrencies({ commit }){
        commit('setCurrencies', null)
        commit('setLoadingCurrencies', false)
    }

}
export default {
    state,
    getters,
    mutations,
    actions
}
