const initialState = {
    date: null,
    loadingDate: false,
    dateStatement: '',
}
const state = {
    date: initialState.date,
    loadingDate: initialState.loadingDate,
    dateStatement: initialState.dateStatement
}
const getters = {
    date(state) {
        return state.date
    },
    loadingDate(state) {
        return state.loadingDate
    },
    dateStatement(state) {
        return !state.dateStatement ?moment(state.date).format('DD/MM/YYYY') :state.dateStatement
    },
}
const mutations = {
    setDate(state, payload) {
        state.date = payload
    },
    setLoadingDate(state, loading) {
        state.loadingDate = !!loading
    },
    setDateStatement(state, payload) {
        state.dateStatement = moment(payload).format('DD/MM/YYYY')
    },
}
const actions = {
    initDate({ commit }, payload) {
        commit('setDate',payload)
        commit('setLoadingDate')
    },
    resetDate({ getters, commit }) {
        commit('setLoadingDate', true)
        commit('setDate',null)
        commit('setDateStatement', '')
    },
    dateNewStatement({ commit }, payload) {
        commit('setDateStatement', payload)
    }
}
export default {
    state,
    getters,
    mutations,
    actions
}
