const initialState = {
    journals: null,
    loadingJournals: false,
    selectedJournal: null,
    selectedJournalName: '',
}
const state = {
    journals : initialState.journals,
    loadingJournals: initialState.loadingJournals,
    selectedJournal: initialState.selectedJournal,
    selectedJournalName: initialState.selectedJournalName
}
const getters = {
    journals(state) {
        return state.journals
    },
    loadingJournals(state) {
        return state.loadingJournals
    },
    selectedJournal(state) {
        return state.selectedJournal
    },
    selectedJournalName(state) {
        return state.selectedJournalName
    }
    // getJournalName(state)
}
const mutations = {
    setJournals(state, payload) {
        state.journals = payload
    },
    setLoadingJournals(state, payload) {
        state.loadingJournals = !!payload
    },
    setSelectedJournal(state, payload) {
        state.selectedJournal = !!payload ?payload.id : null
        state.selectedJournalName = !!payload ?payload.name :''
    }
}
const actions = {
    initJournals({ commit }, payload) {
        commit('setJournals', payload)
        commit('setLoadingJournals', payload)
    },
    /* Seleccionar Diario */
    selectJournal({ commit , dispatch}, payload) {
        commit('setSelectedJournal', payload)
        dispatch('filterUserJournalSelected', payload)
    },
    resetJournals({ commit }){
        commit('setJournals', null)
        commit('setLoadingJournals', false)
        commit('setSelectedJournal', null)
    },
}
export default {
    state,
    getters,
    mutations,
    actions
}
