const initialState = {
    resUsers: [],
    selectedUserStatement: null,
    selectedUserName: '',
    visibleUser: []
}
const state = {
    resUsers: initialState.resUsers,
    selectedUserStatement: initialState.selectedUserStatement,
    visibleUser: initialState.visibleUser,
    selectedUserName: initialState.selectedUserName,
}
const getters = {
    resUsers(state) {
        return state.resUsers
    },
    selectedUserStatement(state) {
        return state.selectedUserStatement
    },
    filterUserJournal(state) {
        return state.visibleUser.length === 0 ?state.resUsers :state.visibleUser
    },
    selectedUserName(state) {
        return state.selectedUserName
    }
}
const mutations = {
    setResUsers(state, payload) {
        state.resUsers = payload
    },
    setSelectedUserStatement(state, payload) {

        state.selectedUserStatement = !payload ?null :payload.id
        state.selectedUserName = !payload ?'' :payload.name
    },
    setUserJournalSelected(state, payload) {
        let userFilter = []
        if (!payload){
            return
        }
        for (let store of payload.storeIds ){
            for(let user of state.resUsers) {
                if (!!user.storeIds.find(item => item === store)) {
                    if ((userFilter.length === 0) || !(userFilter.find(item => item.id === user.id))){
                        userFilter.push({
                            'id':  user.id,
                            'name': user.name,
                            'displayName': user.displayName,
                            'image': user.image,
                        })
                    }
                }
            }
        }
        state.visibleUser = userFilter
    }
}
const actions = {
    initResUsers({ commit }, payload){
        commit('setResUsers', payload)
    },
    setSelectUserStatement({ commit }, payload) {
        commit('setSelectedUserStatement', payload)
    },
    filterUserJournalSelected({ commit }, payload) {
        commit('setUserJournalSelected', payload)
    },
    resetResUsers({ commit }) {
        commit('setResUsers', [])
        commit('setSelectedUserStatement', null)
        commit('setUserJournalSelected', null)

    },
}
export default {
    state,
    getters,
    mutations,
    actions
}
