const initialState = {
    isTransfer: false,
    isInputCashbox: false,
    isOutputCashbox: false,
    isStatmentConfirm: false,
    isStatmentModify: false,
    amountOperation: 0,
    description: '',
}
const state = {
    isTransfer: initialState.isTransfer,
    isInputCashbox: initialState.isInputCashbox,
    isOutputCashbox: initialState.isOutputCashbox,
    isStatmentConfirm: initialState.isStatmentConfirm,
    amountOperation: initialState.amountOperation,
    description: initialState.description,
    isStatmentModify: initialState.isStatmentModify,
}
const getters = {
    isTransfer(state) {
        return state.isTransfer;
    },
    isInputCashbox(state) {
        return  state.isInputCashbox;
    },
    isOutputCashbox(state) {
        return state.isOutputCashbox;
    },
    isStatmentConfirm(state) {
        return state.isStatmentConfirm
    },
    isStatmentModify(state) {
        return state.isStatmentModify
    },
    amountOperation(state) {
        return state.amountOperation
    },
    description(state) {
        return state.description
    },
    operationTitle(state){
        if (state.isTransfer) {
            return 'Transferencia interna de cajas'
        }
        if (state.isInputCashbox) {
            return 'Entrada de dinero'
        }
        if (state.isOutputCashbox) {
            return 'Extracciónes de valores'
        }
        if (state.isStatmentConfirm) {
            return 'Cierre de Caja'
        }
    }
}
const mutations = {
    setTransfer(state, payload) {
        state.isTransfer = payload
    },
    setInputCashbox(state, payload) {
        state.isInputCashbox = payload
    },
    setOutputCashbox(state, payload) {
        state.isOutputCashbox = payload
    },
    setStatmentConfirm( state, payload) {
        state.isStatmentConfirm = payload
    },
    setStatmentModify(state, payload) {
        state.isStatmentModify = payload
    },
    /* amountOperation */
    setAmountOperation(state, payload) {
        state.amountOperation = payload
    },
    setDescription(state, payload) {
        state.description = payload
    },
}

const actions = {
    /* Transferencia */
    clcikTransfer({ commit, dispatch }, payload) {
        commit('setTransfer', payload)
        commit('setInputCashbox', false)
        commit('setOutputCashbox', false)
        commit('setStatmentConfirm', false)
        commit('setStatmentModify', false)
        dispatch('filteredStatementsDest')
    },
    /* Input */
    clickInputCashbox({ commit }, payload) {
        commit('setTransfer', false)
        commit('setInputCashbox', payload)
        commit('setOutputCashbox', false)
        commit('setStatmentConfirm', false)
        commit('setStatmentModify', false)
    },
    /* Output */
    clickOutputCashbox({ commit }, payload) {
        commit('setTransfer', false)
        commit('setInputCashbox', false)
        commit('setOutputCashbox', payload)
        commit('setStatmentConfirm', false)
        commit('setStatmentModify', false)
    },
    /* Config */
    clcikConfig({ commit, dispatch, getters },payload) {
        commit('setStatmentConfirm', payload)
        commit('setTransfer', false)
        commit('setInputCashbox', false)
        commit('setOutputCashbox', false)
        commit('setStatmentModify', false)
        /* Change amount operation */
        dispatch('changeAmountOperation',getters.amountStatementOrigin)
    },
    /* Write */
    clickModify({ commit, dispatch }, payload) {
        commit('setStatmentModify', payload)
        commit('setTransfer', false)
        commit('setInputCashbox', false)
        commit('setOutputCashbox', false)
        commit('setStatmentConfirm', false)
        dispatch('initLines')
    },
    /* Reset Steps*/
    resetClick({ commit, dispatch }) {
        commit('setStatmentModify', false)
        commit('setTransfer', false)
        commit('setInputCashbox', false)
        commit('setOutputCashbox', false)
        commit('setStatmentConfirm', false)
        dispatch('resetStatementLine')
        dispatch('resetStatemntDest')
    },
    /* AmountOperation */
    changeAmountOperation({ commit }, payload) {
        commit('setAmountOperation', payload)
    },
    /* Description */
    changeDescriptionOperation({ commit }, payload){
        commit('setDescription', payload)
    },
    resetStatementAction({ commit, dispatch }) {
        // dispatch('resetClick')
        commit('setStatmentModify', false)
        commit('setTransfer', false)

        commit('setInputCashbox', false)
        commit('setOutputCashbox', false)
        commit('setStatmentConfirm', false)
        dispatch('resetStatementLine')
        dispatch('resetStatemntDest')
        commit('setAmountOperation', 0)
        commit('setDescription', '')
    },
}

export default {
    state,
    getters,
    mutations,
    actions
}
