const initialState = {
    statementType: [],
    loadingStatementType: false,
    selectedStatementType: null, // is type statement Create Statement
    selectedStatementTypeName: '' // is type statement Create Statement
}
const state ={
    statementType: initialState.statementType,
    loadingStatementType: initialState.loadingStatementType,
    selectedStatementType: initialState.selectedStatementType,
    selectedStatementTypeName: initialState.selectedStatementTypeName,
}
const getters = {
    statementType(state) {
        return  state.statementType;
    },
    loadingStatementType(state) {
        return  state.loadingStatementType;
    },
    selectedStatementType(state) {
        return  state.selectedStatementType;
    },
    selectedStatementTypeName(state) {
        return state.selectedStatementTypeName
    }
}
const mutations = {
    setStatementType(state, payload) {
        state.statementType = payload
    },
    setLoadingStatementType(state, payload) {
        state.loadingStatementType = !!payload
    },
    setSelectedStatementType(state, payload) {
        state.selectedStatementType = !payload ?null :payload.id
        state.selectedStatementTypeName =!payload ?'' :payload.name
    }
}
const actions = {
    initStatementType({ commit }, payload) {
        commit('setStatementType', payload)
        commit('setLoadingStatementType', payload)
    },
    selectStatementType({ commit }, payload) {
        commit('setSelectedStatementType', payload)

    },
    resetStatementType({ commit }) {
        commit('setStatementType', [])
        commit('setLoadingStatementType', false)
        commit('setSelectedStatementType', null)
    },
}

export default {
    state,
    getters,
    mutations,
    actions
}
