const initialState = {
    user: [],
    loadingUser: false
}

const state = {
    user: initialState.user,
    loadingUser: initialState.loadingUser
}

const getters = {
    user(state) {
        return state.user;
    },
    loadingUser(state) {
        return state.loadingUser
    }
}

const mutations = {
    setUser(state, payload) {
        state.user = payload
    },
    setLoadingUser(state, payload) {
        state.loadingUser = !!payload
    }
}

const actions = {
    initUser({ commit }, payload) {
        commit('setUser', payload)
        commit('setLoadingUser', payload)
    },
    resetUser({ commit }){
        commit('setUser', [])
        commit('setLoadingUser', false)
    }
}

export default{
    state,
    getters,
    mutations,
    actions
}
